mb = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "CandyBar-2.0","AceDB-2.0" )
mb:RegisterDB("mbDB","mbDBPC");
mb:RegisterDefaults("profile", {
x=700,
y=-350,
scale=0.7
} )

local xres, yres = 0,0;

local gain={
["Drums of Battle"]="red",
["Heroism"]="red",
["Unleashed Rage"]="red",
["Flurry"]="red",
["Invigorated"]="white",
["Rage of the Unraveller"]="red",
["Lust for Battle"]="red",
["Fury of the Crashing Waves"]="red",
["Lightning Speed"]="red",
["Haste"]="red",
["Magtheridon Melee Trinket"]="red",
["Shield"]="blue",
["Shamanistic Rage"]="yellow",
["Battle Shout"]="orange",
["Blessing of Kings"]="orange",
["Blessing of Might"]="orange",
["Blessing of Salvation"]="orange",
["Flask of"]="orange",
["of Shattrath"]="orange",
["Well Fed"]="orange"
}

local gaintime={
["Drums of Battle"]=30,
["Heroism"]=40,
["Unleashed Rage"]=10,
["Flurry"]=15,
["Invigorated"]=15,
["Rage of the Unraveller"]=10,
["Lust for Battle"]=20,
["Fury of the Crashing Waves"]=10,
["Lightning Speed"]=15,
["Haste"]=10,
["Magtheridon Melee Trinket"]=10,
["Shield"]=600,
["Shamanistic Rage"]=30,
["Battle Shout"]=180,
["Blessing of Kings"]=900,
["Blessing of Might"]=900,
["Blessing of Salvation"]=900,
["Flask of"]=7200,
["of Shattrath"]=7200,
["Well Fed"]=1800
}

local options = {};

function mb:OnEnable()
	self:RegisterEvent("UNIT_AURA","BuffChange");
	self:RegisterEvent("PLAYER_AURAS_CHANGED","BuffChange");
	mb:BuffcandySET();
	mb:BuffChange();
	mb:getscreenres();
	mb:setoptions();
	mb:RegisterChatCommand("/mb", "/MB", options);
end

function mb:BuffcandySET()
		mb:RegisterCandyBarGroup("Buffcandy");
		mb:SetCandyBarGroupPoint("Buffcandy", "TOPLEFT", "UIParent", "TOPLEFT",mb.db.profile.x/mb.db.profile.scale,mb.db.profile.y/mb.db.profile.scale);
end

function mb:BuffChange()
	if ((not arg1) or (arg1=="player")) then
		for i=1,32 do
			if (mb:IsCandyBarRegistered("BuffBAR" .. i)) then
				mb:UnregisterCandyBar("BuffBAR" .. i);
			end
			local buffid,cancel = GetPlayerBuff(i,"HELPFUL");
			if(buffid > -1) then
				local name,_=GetPlayerBuffName(buffid);
				if (name) then
					for buff,bcol in pairs(gain) do
						if((string.find(name,buff)) and (gaintime[buff])) then
							local btimeLeft = GetPlayerBuffTimeLeft(buffid);
							local count=GetPlayerBuffApplications(buffid);
							local iconTexture=GetPlayerBuffTexture(buffid);
							if (count>1) then
								mb:RegisterCandyBar("BuffBAR" .. i,gaintime[buff],name .. " (" .. count .. ")",iconTexture);
							else
								mb:RegisterCandyBar("BuffBAR" .. i,gaintime[buff],name,iconTexture);
							end
							mb:SetCandyBarColor("BuffBAR" .. i,bcol,0.5);
							mb:SetCandyBarScale("BuffBAR" .. i, mb.db.profile.scale);
							mb:RegisterCandyBarWithGroup("BuffBAR" .. i,"Buffcandy");
							mb:SetCandyBarTimeLeft("BuffBAR" .. i,btimeLeft);
							mb:StartCandyBar("BuffBAR" .. i);
						end
					end
				end
			end
		end
	end
end

function mb:getscreenres()
	local xyres=GetCVar("gxResolution");
	xres, yres=strsplit("x",xyres);
	xres=tonumber(xres);
	yres=tonumber(yres);
	-- DEFAULT_CHAT_FRAME:AddMessage(xres.." "..yres);
end

function mb:setoptions()
	options = { 
	    type='group',
	    args = {
	       buffx = {
	            type = 'range',
	            name = 'Buffx',
	            desc = 'Change X coord of Buffs timer',
	            min = 0,
				max = xres,
				step = 1,
				get = function()
			        return mb.db.profile.x
			    end,
	            set = function(v)
			        mb.db.profile.x=v;
					mb:SetCandyBarGroupPoint("Buffcandy", "TOPLEFT", "UIParent", "TOPLEFT",mb.db.profile.x/mb.db.profile.scale,mb.db.profile.y/mb.db.profile.scale);
					mb:RegisterCandyBar("testbuff",10,"Test Buff");
					mb:SetCandyBarScale("testbuff",mb.db.profile.scale);
					mb:RegisterCandyBarWithGroup("testbuff","Buffcandy");
					mb:StartCandyBar("testbuff");
			    end
	        },
			buffy = {
	            type = 'range',
	            name = 'Buffy',
	            desc = 'Change Y coord of Buffs timer',
	            min = (-1)*yres,
				max = 0,
				step = 1,
				get = function()
			        return mb.db.profile.y
			    end,
	            set = function(v)
			        mb.db.profile.y=v;
					mb:SetCandyBarGroupPoint("Buffcandy", "TOPLEFT", "UIParent", "TOPLEFT",mb.db.profile.x/mb.db.profile.scale,mb.db.profile.y/mb.db.profile.scale);
					mb:RegisterCandyBar("testbuff",10,"Test Buff");
					mb:SetCandyBarScale("testbuff",mb.db.profile.scale);
					mb:RegisterCandyBarWithGroup("testbuff","Buffcandy");
					mb:StartCandyBar("testbuff");
			    end
	        },
			buffscale = {
	            type = 'range',
	            name = 'Buffscale',
	            desc = 'Change Scale of Buffs timer',
	            min = 0.5,
				max = 3,
				step = 0.1,
				get = function()
			        return mb.db.profile.scale
			    end,
	            set = function(v)
					mb.db.profile.scale=v;
			        mb:SetCandyBarGroupPoint("Buffcandy", "TOPLEFT", "UIParent", "TOPLEFT",mb.db.profile.x/mb.db.profile.scale,mb.db.profile.y/mb.db.profile.scale);
					mb:RegisterCandyBar("testbuff",10,"Test Buff");
					mb:SetCandyBarScale("testbuff",mb.db.profile.scale);
					mb:RegisterCandyBarWithGroup("testbuff","Buffcandy");
					mb:StartCandyBar("testbuff");
					for i=1,32 do
						if (mb:IsCandyBarRegistered("BuffBAR" .. i)) then
							mb:SetCandyBarScale("BuffBAR" .. i, mb.db.profile.scale);
						end
					end
			    end
	        }
	    }
	}
end